## unison-2.52 2.52.0

=== Makefile ===
.PHONY: all src

default: text

text:
	$(MAKE) -C src UISTYLE=text

test:
	./src/unison -ui text -selftest

all: src

src:
	$(MAKE) -C src

-include src/Makefile.ProjectInfo

docs:
	$(MAKE) -C src UISTYLE=text
	$(MAKE) -C doc

include src/Makefile.OCaml

######################################################################
# Export

ifeq ($(OSARCH),win32)
  BCPHOME=/cygdrive/s
  # BCPHOME=/home/exporting
  EXPORTNATIVE=true
  EXPORTSTATIC=true
else
ifeq ($(OSARCH),win32gnuc)
  BCPHOME=/home/exporting
  EXPORTNATIVE=true
  EXPORTSTATIC=false
else
ifeq ($(OSARCH),linux)
  EXPORTNATIVE=true
  EXPORTSTATIC=false
else
ifeq ($(OSARCH),osx)
  EXPORTNATIVE=true
  EXPORTSTATIC=false
else # Solaris
  EXPORTNATIVE=true
  EXPORTSTATIC=true
endif
endif
  BCPHOME=$(HOME)
endif
endif

EXPORTDIR=$(BCPHOME)/pub/$(NAME)
DOWNLOADAREA=releases
DOWNLOADPARENT=$(EXPORTDIR)/download/$(DOWNLOADAREA)
REALDOWNLOADDIR=$(DOWNLOADPARENT)/$(NAME)-$(VERSION)
BRANCH=$(MAJORVERSION)
EXPORTNAME=$(NAME)-$(VERSION)
# OSX/linux portability
ifeq ($(OSARCH),osx)
	TMP=$(shell mktemp -d -t unison)
else
	TMP=$(shell mktemp -d)
endif
DOWNLOADDIR=/tmp/$(NAME)-$(VERSION)
# DOWNLOADDIR=$(REALDOWNLOADDIR)

# OLD
# Do this when it's time to create a new beta-release from the development trunk
#beta: 
#	@echo "Makefile needs fixing"
#	@exit 1
#	@tools/ask tools/exportmsg.txt
#	(cd ..; svn copy trunk branches/$(BRANCH))
#	(cd ../branches/$(BRANCH); svn commit -m "New release branch")
#	@echo
#	@echo "Press RETURN to export it... "
#	@read JUNK
#	$(MAKE) -C ../branches/$(BRANCH) export

# Do this in a release branch to export a new tarball (e.g., after fixing a bug)
# (builds a beta release)
export:
	@echo
	@echo "CHECKLIST:"
	@echo "  - Bump minor version number in src/Makefile.ProjectInfo"
	@echo "  - Move everything interesting from src/RECENTNEWS to doc/changes.tex"
	@echo ""
	@echo "If all this is done, hit RETURN (otherwise Ctrl-C and do it)"
	@read JUNK
	$(MAKE) $(DOWNLOADDIR)
	$(MAKE) exportdocs
	$(MAKE) exportsources
	(cd $(DOWNLOADDIR); genindexhtml)
	@echo
	@echo "OK to commit?  Press RETURN if yes (Crtl-C if no)..."
	@read JUNK
	$(MAKE) commitexport

commitexport:
	$(MAKE) realcommit
	$(MAKE) mailchanges

realcommit:
	@echo
	@echo Committing new export directory
	mv $(DOWNLOADDIR) $(REALDOWNLOADDIR)
	-chmod -R a+r $(EXPORTDIR)
	-chmod -R g+wr $(EXPORTDIR)
	-chmod -R o-w $(EXPORTDIR)
	-$(RM) $(DOWNLOADPARENT)/beta
	-ln -s $(EXPORTNAME) $(DOWNLOADPARENT)/beta
	(cd $(DOWNLOADPARENT); genindexhtml)

$(DOWNLOADDIR):
	@echo Creating DOWNLOADDIR = $(DOWNLOADDIR)
	@echo
	-mkdir -p $(DOWNLOADDIR)

exportsources:
	git archive --output $(DOWNLOADDIR)/$(EXPORTNAME).tar.gz -- HEAD src

exportdocs:
	-rm -f src/unison
	$(MAKE) -C src UISTYLE=text DEBUGGING=false \
                       NATIVE=$(EXPORTNATIVE) STATIC=$(EXPORTSTATIC)
	-$(RM) src/strings.ml
	$(MAKE) -C doc TEXDIRECTIVES+="\\\\draftfalse" real
	$(MAKE) -C src UISTYLE=text DEBUGGING=false \
                       NATIVE=$(EXPORTNATIVE) STATIC=$(EXPORTSTATIC)
	cp doc/unison-manual.ps $(DOWNLOADDIR)/$(EXPORTNAME)-manual.ps
	-cp doc/unison-manual.pdf $(DOWNLOADDIR)/$(EXPORTNAME)-manual.pdf
	cp doc/unison-manual.html $(DOWNLOADDIR)/$(EXPORTNAME)-manual.html
	cp doc/unison-manual.html $(DOWNLOADDIR)/$(NAME)-manual.html

MAILTMP = $(HOME)/mail.tmp

mailchanges: 
	@echo To: $(NAME)-announce@yahoogroups.com,$(NAME)-users@yahoogroups.com \
            > $(MAILTMP)
	@echo Subject: $(NAME) $(VERSION) now available >> $(MAILTMP)
	@echo >> $(MAILTMP)
	@echo Download address: >> $(MAILTMP)
	@echo "  " http://www.cis.upenn.edu/~bcpierce/unison/download.html \
           >> $(MAILTMP)
	@echo >> $(MAILTMP)
	@src/unison -doc news >> $(MAILTMP)
	@echo "Announcement draft can be found in $(MAILTMP)"

######################################################################
# Export binary for the current architecture
# (this stuff is all probably dead)

EXPORTTMP=$(TMP)/export-$(OSARCH)x.tmp

exportnative:
	-$(RM) -r $(EXPORTTMP)
	cp -r src $(EXPORTTMP)
	$(MAKE) realexportnative
ifeq ($(OSARCH),linux)
	$(MAKE) realexportnative EXPORTSTATIC=true KIND=-static
endif
	$(RM) -r $(EXPORTTMP)

realexportnative:
	-$(MAKE) -C $(EXPORTTMP) clean
	$(MAKE) -C $(EXPORTTMP) UISTYLE=text DEBUGGING=false \
                       NATIVE=$(EXPORTNATIVE) STATIC=$(EXPORTSTATIC)
	-mkdir -p $(DOWNLOADDIR)
	cp $(EXPORTTMP)/$(NAME)$(EXEC_EXT) \
               $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-textui$(EXEC_EXT)
	gzip --best --force -c \
            $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-textui$(EXEC_EXT) \
          > $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-textui$(EXEC_EXT).gz
	$(MAKE) -C $(EXPORTTMP) UISTYLE=gtk2 DEBUGGING=false \
                       NATIVE=$(EXPORTNATIVE) STATIC=$(EXPORTSTATIC)
	cp $(EXPORTTMP)/$(NAME)$(EXEC_EXT) \
               $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-gtkui$(EXEC_EXT)
	gzip --best --force -c \
            $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-gtkui$(EXEC_EXT) \
          > $(DOWNLOADDIR)/$(EXPORTNAME).$(OSARCH)$(KIND)-gtkui$(EXEC_EXT).gz


######################################################################
# Version control

checkin: logmsg remembernews
	git commit -a --file=logmsg
	$(RM) logmsg
	@echo 
	@echo "Remember to do:"
	@echo "   git pull && git push"

remembernews: logmsg
	echo "CHANGES FROM VERSION" $(VERSION) > rc.tmp
	echo >> rc.tmp
	cat logmsg >> rc.tmp
	echo  >> rc.tmp
	echo    ------------------------------- >> rc.tmp
	-cat src/RECENTNEWS >> rc.tmp
	mv -f rc.tmp src/RECENTNEWS

######################################################################
# Misc

depend::
	$(MAKE) -C src depend

clean::
	$(RM) -r *.tmp \
	   *.o *.obj *.cmo *.cmx *.cmi core TAGS *~ *.log \
	   *.aux *.log *.dvi *.out *.backup[0-9] *.bak $(STABLEFLAG)
	$(MAKE) -C doc clean
	$(MAKE) -C src clean

install:
	(cd src; $(MAKE) install)

installtext:
	(cd src; $(MAKE) install UISTYLE=text)

src/$(NAME):
	$(MAKE) -C src

windres:
	windres src/win32rc/unison.rc -O coff src/win32rc/unison.res.lib
	windres src/win32rc/unison.rc -O res src/win32rc/unison.res

=== debian/changelog ===
unison-2.52 (2.52.0-1) unstable; urgency=medium

  * New upstream release
    - do no longer depend on OCaml ABI

 -- Stéphane Glondu <glondu@debian.org>  Sun, 13 Mar 2022 12:39:38 +0100

unison-2.51+4.13.1 (2.51.5-1) unstable; urgency=medium

  * Compile with OCaml 4.13.1
  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jan 2022 10:29:59 +0100

unison-2.51+4.11.1 (2.51.3-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 21 Oct 2020 16:22:34 +0200

unison-2.51+4.11.1 (2.51.3~rc3-1) unstable; urgency=medium

  * New upstream release candidate

 -- Stéphane Glondu <glondu@debian.org>  Sun, 18 Oct 2020 17:48:15 +0200

unison-2.51+4.11.1 (2.51.3~rc2-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures (-custom was misplaced)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 16 Oct 2020 06:02:25 +0200

unison-2.51+4.11.1 (2.51.3~rc2-1) unstable; urgency=medium

  * New upstream release candidate
  * Embed OCaml ABI in the name of packages, executables, etc.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Oct 2020 16:37:56 +0200

unison-2.48 (2.48.4-8) unstable; urgency=medium

  * Stop suggesting -all metapackages
  * Add Breaks: unison{,-gtk} (<< 2.48.4-5~)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Aug 2020 08:34:03 +0200

unison-2.48 (2.48.4-7) unstable; urgency=medium

  * Fix .desktop file for unison-2.48-gtk (Closes: #968050)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 07 Aug 2020 17:00:08 +0200

unison-2.48 (2.48.4-6) unstable; urgency=medium

  * Add Replaces: unison{,-gtk} (<< 2.48.4-5~) (Closes: #967964)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 06 Aug 2020 09:12:02 +0200

unison-2.48 (2.48.4-5) unstable; urgency=medium

  * Create new versioned source package
  * Simplify the packaging
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Thu, 23 Jul 2020 17:10:12 +0200

unison (2.48.4-4) unstable; urgency=medium

  * Rename debian/NEWS.Debian to debian/NEWS so that it is installed

 -- Stéphane Glondu <glondu@debian.org>  Wed, 04 Dec 2019 09:44:32 +0100

unison (2.48.4-3) unstable; urgency=medium

  * Add entry in NEWS.Debian documenting the incompatibility due to
    compilation with a different OCaml version (Closes: #946041)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2019 11:44:57 +0100

unison (2.48.4-2) unstable; urgency=medium

  * Fix compilation with OCaml 4.08.1
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Dec 2019 13:26:31 +0100

unison (2.48.4-1) unstable; urgency=medium

  * New upstream release (Closes: #878462)
  * Update Vcs-*
  * Bump Standards-Version to 4.1.1
  * Remove menu file

 -- Stéphane Glondu <glondu@debian.org>  Mon, 30 Oct 2017 10:26:00 +0100

unison (2.48.3-1) unstable; urgency=medium

  * New upstream release (Closes: #705318)
    - remove obsolete patches (fixed upstream)
    - fix debian/generate-manpage.ml
    - thanks to Yuri Kanivetsky for preliminary updating work
    - make temp file names fit within 143 characters (Closes: #504503)
  * Do not use absolute path to icon in desktop file (Closes: #777238)
  * Update debian/copyright
  * Update bash completion installation directory
  * Bump debhelper compat level to 9
  * Bump Standards-Version to 3.9.6

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Aug 2015 14:57:24 +0200

unison (2.40.102-2) unstable; urgency=low

  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Sat, 11 May 2013 12:03:12 +0200

unison (2.40.102-1) experimental; urgency=low

  * New upstream release
    - compatibility with OCaml >= 4 (Closes: #691683)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 17 Apr 2013 14:44:24 +0200

unison (2.40.65-2) unstable; urgency=low

  * Refer to unison-manual.txt.gz in doc-base (Closes: #657496)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 15 Apr 2012 18:02:55 +0200

unison (2.40.65-1) unstable; urgency=low

  * New upstream release
    - fix -doc option (Closes: #657496, LP: #949895)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Apr 2012 17:55:06 +0200

unison (2.40.63-3) unstable; urgency=low

  * Suggest unison-all
  * Use rsvg-convert instead of rsvg (Closes: #666312)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 31 Mar 2012 19:16:19 +0200

unison (2.40.63-2) unstable; urgency=low

  * Remove unison-gtk alternative on uninstall (Closes: #657420)
  * Add myself to Uploaders, remove Sylvain
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Thu, 26 Jan 2012 07:03:15 +0100

unison (2.40.63-1) experimental; urgency=low

  * Team upload
  * New upstream release (Closes: #641462)
    - remove all former patches; the issues they fix seem to have been
      addressed upstream
    - add a new patch to fix all typos reported by Lintian
  * debian/control:
    - remove build-dependency to quilt
    - replace Conflicts by Replaces/Breaks
    - bump Standards-Version to 3.9.2 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 08 Jan 2012 14:25:17 +0100

unison (2.32.52-3) unstable; urgency=low

  * Team upload
  * Remove obsolete README.source
  * Add Fix-bad-interaction-with-OpenSSH-5.6.patch (Closes: #620031)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 03 Apr 2011 13:16:18 +0200

unison (2.32.52-2) unstable; urgency=low

  * Team upload
  * Switch source package format to 3.0 (quilt)
  * Add patch to fix build with OCaml 3.12 (Closes: #585453)
  * Add "set -e" to maintainer scripts
  * Remove conflicts older than oldstable
  * Bump Standards-Version to 3.9.1

 -- Stéphane Glondu <glondu@debian.org>  Thu, 10 Feb 2011 12:21:24 +0100

unison (2.32.52-1) unstable; urgency=low

  * New upstream release (Closes: #559054)
  * Merge changes from unison2.27.57:
    * Move ${F:OtherUnison*} fields first due to a problem when merging


=== debian/control ===
Source: unison-2.52
Section: utils
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 liblablgtk2-ocaml-dev,
 librsvg2-bin,
 imagemagick,
 dh-ocaml
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/unison.git -b 2.52/debian
Vcs-Browser: https://salsa.debian.org/ocaml-team/unison/-/tree/2.52/debian
Homepage: http://www.cis.upenn.edu/~bcpierce/unison/

Package: unison-2.52
Architecture: any
Depends: ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Recommends: ssh-client | openssh-client
Breaks: unison (<< 2.48.4-5~)
Replaces: unison (<< 2.48.4-5~)
Description: file-synchronization tool for Unix and Windows
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.

Package: unison-2.52-gtk
Architecture: any
Depends: unison-2.52, ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Recommends: ssh-askpass, ssh-client | openssh-client
Breaks: unison-gtk (<< 2.48.4-5~)
Replaces: unison-gtk (<< 2.48.4-5~)
Description: file-synchronization tool for Unix and Windows with GTK+ interface
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.
 .
 This package adds the optional GTK+ interface.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for unison package

include /usr/share/ocaml/ocamlvars.mk

VERSION := 2.52
UNISON_ABI := $(VERSION)

DOCS := src/TODO.txt unison-manual.txt NEWS.md

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
  NATIVE := true
else
  NATIVE := false
endif

SED_REPLACE := -e "s/@UNISON_PACKAGE@/unison-$(UNISON_ABI)/g"

SED_REPLACE_TEXT := -e "s/@UNISON_MAJ@/UNISON-$(UNISON_ABI)/g"
SED_REPLACE_TEXT += -e "s/@UNISON@/unison-$(UNISON_ABI)/g"

SED_REPLACE_GTK := -e "s/@UNISON_MAJ@/UNISON-$(UNISON_ABI)-GTK/g"
SED_REPLACE_GTK += -e "s/@UNISON@/unison-$(UNISON_ABI)-gtk/g"

%:
	dh $@ --with ocaml

override_dh_clean:
	dh_clean
	rm -f debian/unison.1.in debian/unison-$(UNISON_ABI).install debian/unison-$(UNISON_ABI)-gtk.install

override_dh_auto_configure:
	sed -e "s/@UnisonVersion@/$(VERSION)/g" -e "s/@UnisonABI@/$(UNISON_ABI)/g" debian/control.in > debian/control.new
	diff -u debian/control debian/control.new
	rm -f debian/control.new
	dh_auto_configure

override_dh_auto_clean:
	$(MAKE) clean
	rm -f src/ubase/depend
	rm -f unison-text unison-gtk
	rm -f unison-manual.txt unison.1.in
	rm -f debian/unison-gtk.png debian/unison-gtk.xpm

override_dh_auto_build: unison-text unison-gtk unison-manual.txt debian/unison.1.in debian/unison-gtk.png debian/unison-gtk.xpm

override_dh_auto_install:
# Text version
	mkdir -p debian/tmp/usr/bin
	cp unison-text debian/tmp/usr/bin/unison-$(UNISON_ABI)
	mkdir -p debian/tmp/usr/share/man/man1
	sed $(SED_REPLACE) $(SED_REPLACE_TEXT) debian/unison.1.in > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI).1
	mkdir -p debian/tmp/usr/share/doc/unison-$(UNISON_ABI)
	cp $(DOCS) debian/tmp/usr/share/doc/unison-$(UNISON_ABI)
	sed $(SED_REPLACE) $(SED_REPLACE_TEXT) debian/unison.install.in > debian/unison-$(UNISON_ABI).install
# GTK version
	cp unison-gtk debian/tmp/usr/bin/unison-$(UNISON_ABI)-gtk
	sed $(SED_REPLACE) $(SED_REPLACE_GTK) debian/unison.1.in > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI)-gtk.1
	mkdir -p debian/tmp/usr/share/pixmaps
	cp debian/unison-gtk.xpm debian/tmp/usr/share/pixmaps/unison-$(UNISON_ABI)-gtk.xpm
	cp debian/unison-gtk.svg debian/tmp/usr/share/pixmaps/unison-$(UNISON_ABI)-gtk.svg
	mkdir -p debian/tmp/usr/share/applications
	sed $(SED_REPLACE) $(SED_REPLACE_GTK) debian/unison-gtk.desktop.in > debian/tmp/usr/share/applications/unison-$(UNISON_ABI)-gtk.desktop
	sed $(SED_REPLACE) $(SED_REPLACE_GTK) debian/unison-gtk.install.in > debian/unison-$(UNISON_ABI)-gtk.install

override_dh_auto_test:

unison-text:
	$(MAKE) clean
	$(MAKE) -C src UISTYLE=text NATIVE=$(NATIVE) CFLAGS=
	cp src/unison $@

unison-gtk:
	$(MAKE) clean
	$(MAKE) -C src UISTYLE=gtk2 NATIVE=$(NATIVE) CFLAGS=
	cp src/unison $@

unison-manual.txt: unison-text
	./unison-text -doc all > $@

debian/unison.1.in: unison-text
	cp debian/unison-intro.1.in $@
	ocaml debian/generate-manpage.ml ./unison-text >> $@
	cat debian/unison-outro.1.in >> $@

debian/unison-gtk.png: debian/unison-gtk.svg
	rsvg-convert -f png -w 32 -h 32 -o $@ $^

debian/unison-gtk.xpm: debian/unison-gtk.png
	convert $^ $@

## unison-2.52 2.52.1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 test:
 	./src/unison -ui text -selftest
 
-all: src
+all: src manpage
 
 src:
 	$(MAKE) -C src
@@ -18,6 +18,10 @@
 docs:
 	$(MAKE) -C src UISTYLE=text
 	$(MAKE) -C doc
+	$(MAKE) -C man
+
+manpage:
+	$(MAKE) -C man
 
 include src/Makefile.OCaml
 
@@ -212,6 +216,7 @@
 	   *.o *.obj *.cmo *.cmx *.cmi core TAGS *~ *.log \
 	   *.aux *.log *.dvi *.out *.backup[0-9] *.bak $(STABLEFLAG)
 	$(MAKE) -C doc clean
+	$(MAKE) -C man clean
 	$(MAKE) -C src clean
 
 install:

=== man/Makefile ===
-include ../src/Makefile.ProjectInfo

all:: $(NAME).1

../src/$(NAME)$(EXEC_EXT):
	$(MAKE) -C ../src UISTYLE=text

$(NAME).1: $(NAME).1.in opt_short.tmp opt_full.tmp
	sed -e '/@OPTIONS_SHORT@/r./opt_short.tmp' \
		-e '/@OPTIONS_SHORT@/d' \
		-e '/@OPTIONS_FULL@/r./opt_full.tmp' \
		-e '/@OPTIONS_FULL@/d' $(NAME).1.in > $(NAME).1

# Listing of preferences
opt_short.tmp: ../src/$(NAME)$(EXEC_EXT)
	../src/$(NAME)$(EXEC_EXT) -prefsman short > opt_short.tmp

opt_full.tmp: ../src/$(NAME)$(EXEC_EXT)
	../src/$(NAME)$(EXEC_EXT) -prefsman full > opt_full.tmp

clean::
	$(RM) *.tmp $(NAME).1

=== src/lwt/Makefile ===

NAME = lwt

OCAMLC = ocamlfind ocamlc -g
OCAMLOPT = ocamlfind ocamlopt
OCAMLDEP = ocamldep

OBJECTS  = pqueue.cmo lwt.cmo lwt_util.cmo lwt_unix.cmo
XOBJECTS = $(OBJECTS:cmo=cmx)

ARCHIVE  = $(NAME).cma
XARCHIVE = $(NAME).cmxa

REQUIRES =
PREDICATES =

all: $(ARCHIVE) 
opt: $(XARCHIVE)

$(ARCHIVE): $(OBJECTS)
	$(OCAMLC) -a -o $(ARCHIVE) -package "$(REQUIRES)" -linkpkg \
	          -predicates "$(PREDICATES)" $(OBJECTS)
$(XARCHIVE): $(XOBJECTS)
	$(OCAMLOPT) -a -o $(XARCHIVE) -package "$(REQUIRES)" -linkpkg \
	          -predicates "$(PREDICATES)" $(XOBJECTS)

.SUFFIXES: .cmo .cmi .cmx .ml .mli

.ml.cmo:
	$(OCAMLC) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<
.mli.cmi:
	$(OCAMLC) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<
.ml.cmx:
	$(OCAMLOPT) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<

depend: *.ml *.mli
	$(OCAMLDEP) *.ml *.mli > depend
include depend

install: all
	{ test ! -f $(XARCHIVE) || extra="$(XARCHIVE) "`basename $(XARCHIVE) .cmxa`.a; }; \
	ocamlfind install $(NAME) *.mli *.cmi $(ARCHIVE) META $$extra

uninstall:
	ocamlfind remove $(NAME)

clean::
	$(RM) -f *.cmi *.cmo *.cmx *.cma *.cmxa *.a *.{o,obj} *~ *.bak
	$(RM) -f generic/*.cm[ioxa] generic/*.cmxa generic/*.a generic/*.{o,obj} generic/*~ generic/*.bak
	$(RM) -f win/*.cm[ioxa] win/*.cmxa win/*.a win/*.{o,obj} win/*~ win/*.bak

clean::
	cd example && $(MAKE) clean

=== src/fsmonitor/windows/Makefile ===

FSMONITOR = unison-fsmonitor

DIR=fsmonitor/windows
FSMOCAMLOBJS = \
   ubase/umarshal.cmo \
   ubase/rx.cmo unicode_tables.cmo unicode.cmo \
   system/system_generic.cmo system/system_win.cmo \
   system/win/system_impl.cmo \
   lwt/lwt.cmo lwt/pqueue.cmo lwt/win/lwt_unix_impl.cmo lwt/lwt_unix.cmo \
   lwt/win/lwt_win.cmo \
   fsmonitor/watchercommon.cmo $(DIR)/watcher.cmo
FSMCOBJS = \
   bytearray_stubs$(OBJ_EXT) \
   system/system_win_stubs$(OBJ_EXT) lwt/lwt_unix_stubs$(OBJ_EXT)
FSMOCAMLLIBS=bigarray.cma unix.cma

ifeq ($(NATIVE), true)
  FSMCAMLOBJS=$(subst .cmo,.cmx, $(FSMOCAMLOBJS))
  FSMCAMLLIBS=$(subst .cma,.cmxa, $(FSMOCAMLLIBS))
else
  FSMCAMLOBJS=$(FSMOCAMLOBJS)
  FSMCAMLLIBS=$(FSMOCAMLLIBS)
endif

buildexecutable:: $(FSMONITOR)$(EXEC_EXT)

$(FSMONITOR)$(EXEC_EXT): $(COMPATOCAMLOBJS) $(FSMCAMLOBJS) $(FSMCOBJS)
	@echo Linking $@
	$(CAMLC) -verbose $(CAMLFLAGS) $(CAMLLDFLAGS) -o $@ $(CFLAGS) $(FSMCAMLLIBS) $^ $(CLIBS)

clean::
	rm -f $(DIR)/*.cm[iox] $(DIR)/*.{o,obj} $(DIR)/*~
	rm -f $(FSMONITOR)$(EXEC_EXT)

=== debian/changelog ===
unison-2.52 (2.52.1-1) unstable; urgency=medium

  * New upstream release (Closes: #844321)
    - use upstream manpage
  * Bump Standards-Version to 4.6.1

 -- Stéphane Glondu <glondu@debian.org>  Mon, 24 Oct 2022 11:32:17 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  librsvg2-bin,
  imagemagick,
  dh-ocaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/unison.git -b 2.52/debian
 Vcs-Browser: https://salsa.debian.org/ocaml-team/unison/-/tree/2.52/debian

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 override_dh_clean:
 	dh_clean
-	rm -f debian/unison.1.in debian/unison-$(UNISON_ABI).install debian/unison-$(UNISON_ABI)-gtk.install
+	rm -f unison.1 debian/unison-$(UNISON_ABI).install debian/unison-$(UNISON_ABI)-gtk.install
 
 override_dh_auto_configure:
 	sed -e "s/@UnisonVersion@/$(VERSION)/g" -e "s/@UnisonABI@/$(UNISON_ABI)/g" debian/control.in > debian/control.new
@@ -39,23 +39,23 @@
 	$(MAKE) clean
 	rm -f src/ubase/depend
 	rm -f unison-text unison-gtk
-	rm -f unison-manual.txt unison.1.in
+	rm -f unison-manual.txt unison.1
 	rm -f debian/unison-gtk.png debian/unison-gtk.xpm
 
-override_dh_auto_build: unison-text unison-gtk unison-manual.txt debian/unison.1.in debian/unison-gtk.png debian/unison-gtk.xpm
+override_dh_auto_build: unison-text unison-gtk unison-manual.txt debian/unison-gtk.png debian/unison-gtk.xpm
 
 override_dh_auto_install:
 # Text version
 	mkdir -p debian/tmp/usr/bin
 	cp unison-text debian/tmp/usr/bin/unison-$(UNISON_ABI)
 	mkdir -p debian/tmp/usr/share/man/man1
-	sed $(SED_REPLACE) $(SED_REPLACE_TEXT) debian/unison.1.in > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI).1
+	sed $(SED_REPLACE) $(SED_REPLACE_TEXT) unison.1 > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI).1
 	mkdir -p debian/tmp/usr/share/doc/unison-$(UNISON_ABI)
 	cp $(DOCS) debian/tmp/usr/share/doc/unison-$(UNISON_ABI)
 	sed $(SED_REPLACE) $(SED_REPLACE_TEXT) debian/unison.install.in > debian/unison-$(UNISON_ABI).install
 # GTK version
 	cp unison-gtk debian/tmp/usr/bin/unison-$(UNISON_ABI)-gtk
-	sed $(SED_REPLACE) $(SED_REPLACE_GTK) debian/unison.1.in > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI)-gtk.1
+	sed $(SED_REPLACE) $(SED_REPLACE_GTK) unison.1 > debian/tmp/usr/share/man/man1/unison-$(UNISON_ABI)-gtk.1
 	mkdir -p debian/tmp/usr/share/pixmaps
 	cp debian/unison-gtk.xpm debian/tmp/usr/share/pixmaps/unison-$(UNISON_ABI)-gtk.xpm
 	cp debian/unison-gtk.svg debian/tmp/usr/share/pixmaps/unison-$(UNISON_ABI)-gtk.svg
@@ -68,6 +68,8 @@
 unison-text:
 	$(MAKE) clean
 	$(MAKE) -C src UISTYLE=text NATIVE=$(NATIVE) CFLAGS=
+	$(MAKE) manpage
+	cp man/unison.1 .
 	cp src/unison $@
 
 unison-gtk:
@@ -78,11 +80,6 @@
 unison-manual.txt: unison-text
 	./unison-text -doc all > $@
 
-debian/unison.1.in: unison-text
-	cp debian/unison-intro.1.in $@
-	ocaml debian/generate-manpage.ml ./unison-text >> $@
-	cat debian/unison-outro.1.in >> $@
-
 debian/unison-gtk.png: debian/unison-gtk.svg
 	rsvg-convert -f png -w 32 -h 32 -o $@ $^
